/*	gplot.c
*
*	plot of x,y data read from specified file
*   -- free format plot and read (one x,y pair per line in file)
*   -- option for point-plot or line-plot
*/

main(ac, av)
int ac;
char *av[];
	{
	int fnbr;
	double xmin, ymin, xmax, ymax;

	if (ac != 3)
		{
		printf("\nUsage:  gplot <filespec> <lineflag>\n");
		printf("\n<filespec>  file containing data to plot");
		printf("\n<lineflag>  0 for point-plot, 1 for line-plot\n");
		exit(0);
		}
	if ((fnbr = fopen(av[1], "r")) == 0)
		{
		printf("Can't open %s", av[1]);
		exit(0);
		}
	gmode();
	gpage(1);
	clrscr();
	disp(1);
	_fplot(fnbr, atoi(av[2]), &xmin, &ymin, &xmax, &ymax);
	ci();
	tmode();
	printf("\n xmin = %e\n xmax = %e\n", xmin, xmax);
	printf("\n ymin = %e\n ymax = %e\n", ymin, ymax);	
	printf("\n");
	fclose(fnbr);
	}


_fplot(fin, drawflag, xlo, ylo, xhi, yhi)
int fin;
int drawflag;
double *xlo, *xhi, *ylo, *yhi;
 	{
 	int line;
 	char buf[100];
	double x, y;

	line = 0;
	while (fgets(buf,80,fin) != 0)  /* find lo & hi values of x & y */
 		{
 		sscanf(buf, "%lf %lf", &x, &y);
 		if (line == 0)
 			{
 			*xlo = *xhi = x;
 			*ylo = *yhi = y;
 			}
 		else
 			{
	 		if (x < *xlo)
 				*xlo = x;
	 		else if (x > *xhi)
			 	*xhi = x;
	 		if (y < *ylo)
	 			*ylo = y;
	 		else if (y > *yhi)
	 			*yhi = y;
	 		}
	 	++line;
    	}

	rewind(fin);
	line = 0;
 	while (fgets(buf,80,fin) != 0)  /* plot (x, y) points on console */
 		{
 		sscanf(buf, "%lf %lf", &x, &y);
		plotxy(drawflag, line, x, y, xlo, xhi, ylo, yhi);
		++line;
    	}
    frame();
    }

plotxy(drawflag, k, x, y, xlo, xhi, ylo, yhi)
	int drawflag, k;
	double x, y, *xlo, *xhi, *ylo, *yhi;
	{
	int c, clo, chi, r, rlo, rhi;
	clo = 0;
	chi = 719;
	rlo = 0;
	rhi = 347;

	c = clo + (chi - clo) * (x - *xlo) / (*xhi - *xlo);
	r = rlo + (rhi - rlo) * (*yhi - y) / (*yhi - *ylo);

	if (drawflag)
		{
		if (k==0)
			move(c, r);
		dline(c, r);
		}
	else
		plot(c, r);
	}

frame()
	{
	int clo, chi, r, rlo, rhi;

	clo = 0;
	chi = 719;
	rlo = 0;
	rhi = 347;

	move(clo, rlo);
	dline(clo, rhi);
	dline(chi, rhi);
	dline(chi, rlo);
	dline(clo, rlo);
	}
	
